//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 clrGreen
#property indicator_color2 clrRed
#property indicator_color3 clrGreen
#property indicator_color4 clrRed
double up[];
double down[];
double up1[];
double down1[];
extern double fastMA = 50;
extern double slowMA = 200;
extern int arrowDST=120;
datetime candle_time=0;
datetime current_time=0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   SetIndexBuffer(0,up);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexLabel(0,"UP");
   SetIndexBuffer(1,down);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexLabel(1,"DOWN");

   SetIndexBuffer(2,up1);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,225);
   SetIndexLabel(2,"UP1");
   SetIndexBuffer(3,down1);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,226);
   SetIndexLabel(3,"DOWN1");

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   current_time=Time[0];
   int limit= MathMax(rates_total-prev_calculated,2);
   for(int i=1;i<limit;i++)
     {
      double iMA_Fast = iMA(NULL,0,fastMA,0,MODE_SMA,PRICE_CLOSE,i+2);
      double iMA_Slow = iMA(NULL,0,slowMA,0,MODE_SMA,PRICE_CLOSE,i+2);

      //---50MA
      if //up 1
      (Low[i+2]>iMA_Fast && 
       Low[i+1]<iMA_Fast && 
       Open[i+1]>iMA_Fast && 
       Close[i+1]>iMA_Fast && 
       Close[i]>Open[i] && 
       Close[i]>High[i+1] && 
       Close[i]>High[i+2] && 
       iMA_Fast>iMA_Slow)
        {
         up[i+1]=Low[i+1]-arrowDST*Point;
         if(current_time!=candle_time && i==1)
           {
            Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
            SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
           }
         candle_time=Time[0];
        }
      else if //up 2
         (Low[i+1]>iMA_Fast && 
          Low[i]<iMA_Fast && 
          Close[i]>iMA_Fast && 
          Open[i]>iMA_Fast && 
          Close[i]>High[i+1] && 
          iMA_Fast>iMA_Slow)
           {
            up[i]=Low[i]-arrowDST*Point;
            if(current_time!=candle_time && i==1)
              {
               Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
               SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
              }
            candle_time=Time[0];
           }

         else if //up 3
            (Low[i+3]>iMA_Fast && 
             Low[i+2]<iMA_Fast && 
             Close[i+2]>iMA_Fast && 
             Open[i+2]>iMA_Fast && 
             Open[i+1]<Close[i+1] && 
             Close[i]>High[i+1] && 
             Close[i]>High[i+2] && 
             Close[i]>High[i+3] && 
             iMA_Fast>iMA_Slow)
              {
               up[i+2]=Low[i+2]-arrowDST*Point;
               if(current_time!=candle_time && i==1)
                 {
                  Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                  SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                 }
               candle_time=Time[0];
              }

            else if //up 4
               (Low[i+4]>iMA_Fast && 
                Low[i+3]<iMA_Fast && 
                Close[i+3]>iMA_Fast && 
                Open[i+3]>iMA_Fast && 
                Open[i+2]<Close[i+2] && 
                Open[i+1]<Close[i+1] && 
                Close[i]>High[i+1] && 
                Close[i]>High[i+2] && 
                Close[i]>High[i+3] && 
                Close[i]>High[i+4] && 
                iMA_Fast>iMA_Slow)
                 {
                  up[i+3]=Low[i+3]-arrowDST*Point;
                  if(current_time!=candle_time && i==1)
                    {
                     Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                     SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                    }
                  candle_time=Time[0];
                 }

               else if //up 5
                  (Low[i+5]>iMA_Fast && 
                   Low[i+4]<iMA_Fast && 
                   Close[i+4]>iMA_Fast && 
                   Open[i+4]>iMA_Fast && 
                   Open[i+3]<Close[i+3] && 
                   Open[i+2]<Close[i+2] && 
                   Open[i+1]<Close[i+1] && 
                   Close[i]>High[i+1] && 
                   Close[i]>High[i+2] && 
                   Close[i]>High[i+3] && 
                   Close[i]>High[i+4] && 
                   Close[i]>High[i+5] && 
                   iMA_Fast>iMA_Slow)
                    {
                     up[i+4]=Low[i+4]-arrowDST*Point;
                     if(current_time!=candle_time && i==1)
                       {
                        Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                        SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                       }
                     candle_time=Time[0];
                    }

                  //------------------------

                  else if //down 1
                     (High[i+2]<iMA_Fast && 
                      High[i+1]>iMA_Fast && 
                      Open[i+1]<iMA_Fast && 
                      Close[i+1]<iMA_Fast && 
                      Close[i]<Open[i] && 
                      Close[i]<Low[i+1] && 
                      Close[i]<Low[i+2] && 
                      iMA_Fast<iMA_Slow)
                       {
                        down[i+1]=High[i+1]+arrowDST*Point;
                        if(current_time!=candle_time && i==1)
                          {
                           Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                           SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                          }
                        candle_time=Time[0];
                       }

                     else  if //down 2
                        (High[i+1]<iMA_Fast && 
                         High[i]>iMA_Fast && 
                         Close[i]<iMA_Fast && 
                         Open[i]<iMA_Fast && 
                         Close[i]<Low[i+1] && 
                         iMA_Fast<iMA_Slow)
                          {
                           down[i]=High[i]+arrowDST*Point;
                           if(current_time!=candle_time && i==1)
                             {
                              Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                              SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                             }
                           candle_time=Time[0];
                          }

                        else  if //down 3
                           (High[i+3]<iMA_Fast && 
                            High[i+2]>iMA_Fast && 
                            Close[i+2]<iMA_Fast && 
                            Open[i+2]<iMA_Fast && 
                            Open[i+1]>Close[i+1] && 
                            Close[i]<Low[i+1] && 
                            Close[i]<Low[i+2] && 
                            Close[i]<Low[i+3] && 
                            iMA_Fast<iMA_Slow)
                             {
                              down[i+2]=High[i+2]+arrowDST*Point;
                              if(current_time!=candle_time && i==1)
                                {
                                 Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                                 SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                                }
                              candle_time=Time[0];
                             }

                           else  if //down 4
                              (High[i+4]<iMA_Fast && 
                               High[i+3]>iMA_Fast && 
                               Close[i+3]<iMA_Fast && 
                               Open[i+3]<iMA_Fast && 
                               Open[i+2]>Close[i+2] && 
                               Open[i+1]>Close[i+1] && 
                               Close[i]<Low[i+1] && 
                               Close[i]<Low[i+2] && 
                               Close[i]<Low[i+3] && 
                               Close[i]<Low[i+4] && 
                               iMA_Fast<iMA_Slow)
                                {
                                 down[i+3]=High[i+3]+arrowDST*Point;
                                 if(current_time!=candle_time && i==1)
                                   {
                                    Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                                    SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                                   }
                                 candle_time=Time[0];
                                }

                              else  if //down 5
                                 (High[i+5]<iMA_Fast && 
                                  High[i+4]>iMA_Fast && 
                                  Close[i+4]<iMA_Fast && 
                                  Open[i+4]<iMA_Fast && 
                                  Open[i+3]>Close[i+3] && 
                                  Open[i+2]>Close[i+2] && 
                                  Open[i+1]>Close[i+1] && 
                                  Close[i]<Low[i+1] && 
                                  Close[i]<Low[i+2] && 
                                  Close[i]<Low[i+3] && 
                                  Close[i]<Low[i+4] && 
                                  Close[i]<Low[i+5] && 
                                  iMA_Fast<iMA_Slow)
                                   {
                                    down[i+4]=High[i+4]+arrowDST*Point;
                                    if(current_time!=candle_time && i==1)
                                      {
                                       Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                                       SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                                      }
                                    candle_time=Time[0];
                                   }

                                 //---200MA-----------------------------------------------------------------------------------------
                                 if //up 1
                                 (Low[i+2]>iMA_Slow && 
                                  Low[i+1]<iMA_Slow && 
                                  Open[i+1]>iMA_Slow && 
                                  Close[i+1]>iMA_Slow && 
                                  Close[i]>Open[i] && 
                                  Close[i]>High[i+1] && 
                                  Close[i]>High[i+2] && 
                                  iMA_Fast>iMA_Slow)
                                   {
                                    up1[i+1]=Low[i+1]-arrowDST*Point;
                                    if(current_time!=candle_time && i==1)
                                      {
                                       Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                                       SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                                      }
                                    candle_time=Time[0];
                                   }

      else if //up 2
         (Low[i+1]>iMA_Slow && 
          Low[i]<iMA_Slow && 
          Close[i]>iMA_Slow && 
          Open[i]>iMA_Slow && 
          Close[i]>High[i+1] && 
          iMA_Fast>iMA_Slow)
           {
            up1[i]=Low[i]-arrowDST*Point;
            if(current_time!=candle_time && i==1)
              {
               Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
               SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
              }
            candle_time=Time[0];
           }

         else if //up 3
            (Low[i+3]>iMA_Slow && 
             Low[i+2]<iMA_Slow && 
             Close[i+2]>iMA_Slow && 
             Open[i+2]>iMA_Slow && 
             Open[i+1]<Close[i+1] && 
             Close[i]>High[i+1] && 
             Close[i]>High[i+2] && 
             Close[i]>High[i+3] && 
             iMA_Fast>iMA_Slow)
              {
               up1[i+2]=Low[i+2]-arrowDST*Point;
               if(current_time!=candle_time && i==1)
                 {
                  Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                  SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                 }
               candle_time=Time[0];
              }

            else if //up 4
               (Low[i+4]>iMA_Slow && 
                Low[i+3]<iMA_Slow && 
                Close[i+3]>iMA_Slow && 
                Open[i+3]>iMA_Slow && 
                Open[i+2]<Close[i+2] && 
                Open[i+1]<Close[i+1] && 
                Close[i]>High[i+1] && 
                Close[i]>High[i+2] && 
                Close[i]>High[i+3] && 
                Close[i]>High[i+4] && 
                iMA_Fast>iMA_Slow)
                 {
                  up1[i+3]=Low[i+3]-arrowDST*Point;
                  if(current_time!=candle_time && i==1)
                    {
                     Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                     SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                    }
                  candle_time=Time[0];
                 }

               else if //up 5
                  (Low[i+5]>iMA_Slow && 
                   Low[i+4]<iMA_Slow && 
                   Close[i+4]>iMA_Slow && 
                   Open[i+4]>iMA_Slow && 
                   Open[i+3]<Close[i+3] && 
                   Open[i+2]<Close[i+2] && 
                   Open[i+1]<Close[i+1] && 
                   Close[i]>High[i+1] && 
                   Close[i]>High[i+2] && 
                   Close[i]>High[i+3] && 
                   Close[i]>High[i+4] && 
                   Close[i]>High[i+5] && 
                   iMA_Fast>iMA_Slow)
                    {
                     up1[i+4]=Low[i+4]-arrowDST*Point;
                     if(current_time!=candle_time && i==1)
                       {
                        Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                        SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                       }
                     candle_time=Time[0];
                    }

                  //------------------------

                  else if //down 1
                     (High[i+2]<iMA_Slow && 
                      High[i+1]>iMA_Slow && 
                      Open[i+1]<iMA_Slow && 
                      Close[i+1]<iMA_Slow && 
                      Close[i]<Open[i] && 
                      Close[i]<Low[i+1] && 
                      Close[i]<Low[i+2] && 
                      iMA_Fast<iMA_Slow)
                       {
                        down1[i+1]=High[i+1]+arrowDST*Point;
                        if(current_time!=candle_time && i==1)
                          {
                           Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                           SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                          }
                        candle_time=Time[0];
                       }

                     else  if //down 2
                        (High[i+1]<iMA_Slow && 
                         High[i]>iMA_Slow && 
                         Close[i]<iMA_Slow && 
                         Open[i]<iMA_Slow && 
                         Close[i]<Low[i+1] && 
                         iMA_Fast<iMA_Slow)
                          {
                           down1[i]=High[i]+arrowDST*Point;
                           if(current_time!=candle_time && i==1)
                             {
                              Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                              SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                             }
                           candle_time=Time[0];
                          }

                        else  if //down 3
                           (High[i+3]<iMA_Slow && 
                            High[i+2]>iMA_Slow && 
                            Close[i+2]<iMA_Slow && 
                            Open[i+2]<iMA_Slow && 
                            Open[i+1]>Close[i+1] && 
                            Close[i]<Low[i+1] && 
                            Close[i]<Low[i+2] && 
                            Close[i]<Low[i+3] && 
                            iMA_Fast<iMA_Slow)
                             {
                              down1[i+2]=High[i+2]+arrowDST*Point;
                              if(current_time!=candle_time && i==1)
                                {
                                 Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                                 SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                                }
                              candle_time=Time[0];
                             }

                           else  if //down 4
                              (High[i+4]<iMA_Slow && 
                               High[i+3]>iMA_Slow && 
                               Close[i+3]<iMA_Slow && 
                               Open[i+3]<iMA_Slow && 
                               Open[i+2]>Close[i+2] && 
                               Open[i+1]>Close[i+1] && 
                               Close[i]<Low[i+1] && 
                               Close[i]<Low[i+2] && 
                               Close[i]<Low[i+3] && 
                               Close[i]<Low[i+4] && 
                               iMA_Fast<iMA_Slow)
                                {
                                 down1[i+3]=High[i+3]+arrowDST*Point;
                                 if(current_time!=candle_time && i==1)
                                   {
                                    Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                                    SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                                   }
                                 candle_time=Time[0];
                                }

                              else  if //down 5
                                 (High[i+5]<iMA_Slow && 
                                  High[i+4]>iMA_Slow && 
                                  Close[i+4]<iMA_Slow && 
                                  Open[i+4]<iMA_Slow && 
                                  Open[i+3]>Close[i+3] && 
                                  Open[i+2]>Close[i+2] && 
                                  Open[i+1]>Close[i+1] && 
                                  Close[i]<Low[i+1] && 
                                  Close[i]<Low[i+2] && 
                                  Close[i]<Low[i+3] && 
                                  Close[i]<Low[i+4] && 
                                  Close[i]<Low[i+5] && 
                                  iMA_Fast<iMA_Slow)
                                   {
                                    down1[i+4]=High[i+4]+arrowDST*Point;
                                    if(current_time!=candle_time && i==1)
                                      {
                                       Alert((string)Period()+"M ",Symbol()," "+"SIGNAL!");
                                       SendNotification((string)Period()+"M "+Symbol()+" "+"SIGNAL!");
                                      }
                                    candle_time=Time[0];
                                   }

                                }
      return(rates_total);
     }
//+------------------------------------------------------------------+
